//+------------------------------------------------------------------+
//|                                                            d.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red 

//---- input parameters
extern int       period=40;
double ExtMapBuffer1 [];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  SetIndexStyle (0,DRAW_LINE);

  SetIndexBuffer (0, ExtMapBuffer1);

  string short_name = "It's working";
  IndicatorShortName (short_name);
  
  
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   int    counted_bars=IndicatorCounted();
   if (counted_bars<0) return (-1);
   if (counted_bars>0) counted_bars--;
   int count2=0, pos = Bars-counted_bars, emacount=0;
   double pricearray[];
   double logprice[];
   double pricedif[][];
   double pricesum;
   double ema, emapos[], thisbar, lastema, pc[];
   ArrayResize(emapos,Bars);
   double difsum, difave;
   for (;pos>=0; pos--) 
   {
         thisbar=Close[pos];
         lastema=emapos[pos+1];
         ema = ema + (.4 * (thisbar-lastema)); 
         emapos[pos] = ema;
         ExtMapBuffer1[pos] = ema;
         Print(emapos[pos]);
        
   }
         
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+